MYSHELL='which bash'
#!${MYSHELL}

export DECOLINE="+--------------+"
export VERSION="BashBurn 1.3"  # Version of BashBurn - don't change it!
export CONFFILE=/etc/bashburnrc        # Name of BashBurns' config file. Don't change!

# The wait function used below
wait_for_enter()
{
while true; do
        echo "Press [ENTER] to return to main menu."
        read temp
        if [ "$temp" = "" ]; then
                break
        else
                continue
        fi
done
}


# Here starts the reading in of variables
variable_reader()
{
	export ROOTDIR="$( cat ${CONFFILE} | grep -v '^#' | grep ROOTDIR:  | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]//g")"
	export ROOTDIR="${ROOTDIR%*/}"
 
	export CDROM="$(   cat ${CONFFILE} | grep -v '^#' | grep CDROM:    | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]//g")"
        export CDWRITER="$(cat ${CONFFILE} | grep -v '^#' | grep CDWRITER: | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]//g")"
        export SPEED="$(   cat ${CONFFILE} | grep -v '^#' | grep SPEED:    | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]//g")"
        export BLANKING="$(cat ${CONFFILE} | grep -v '^#' | grep BLANKING: | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]//g")"
        export NUMDEV="$(  cat ${CONFFILE} | grep -v '^#' | grep NUMDEV:   | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]//g")"
	export BURNDIR="$( cat ${CONFFILE} | grep -v '^#' | grep BURNDIR:  | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]//g")"
	export BURNDIR="${BURNDIR%*/}"


	# additional informations of a CD:
	export LABEL="$( cat ${CONFFILE} 		| grep -v '^#' 	| grep LABEL:	  	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export COPYRIGHT="$( cat ${CONFFILE} 	| grep -v '^#' 	| grep COPYRIGHT:  	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export DESCRIPTION="$( cat ${CONFFILE} 	| grep -v '^#' 	| grep DESCRIPTION:  	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export AUTHOR="$( cat ${CONFFILE} 	| grep -v '^#'	| grep AUTHOR:  	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export PUBLISHER="$( cat ${CONFFILE} 	| grep -v '^#'	| grep PUBLISHER:	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export NAMEOFPACKAGE="$( cat ${CONFFILE} 	| grep -v '^#'| grep NAMEOFPACKAGE:   | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export NUMBEROFCDS="$( cat ${CONFFILE} 	| grep -v '^#'  | grep NUMBEROFCDS:	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export CURRENTNUMBER="$( cat ${CONFFILE} 	| grep -v '^#'| grep CURRENTNUMBER:	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"

	# some advanced options:
	export NORMALIZE="$( cat ${CONFFILE} 	| grep -v '^#'| grep NORMALIZE:   | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export OPT_ONE="$( cat ${CONFFILE} 	| grep -v '^#'| grep OPT_ONE:   | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export FIFODIR="$( cat ${CONFFILE} 	| grep -v '^#'| grep FIFODIR:   | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export DELTEMPBURN="$( cat ${CONFFILE} 	| grep -v '^#'| grep DELTEMPBURN:   | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export OVERBURN="$( cat ${CONFFILE} 	| grep -v '^#'| grep OVERBURN:   | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export COPY_PROTECT="$( cat ${CONFFILE}     | grep -v '^#'| grep COPY_PROTECT:   | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
}

if [ -r "${CONFFILE}" ]; then	# If /etc/bashburnrc exists, read in the vars.
	variable_reader
	export TEMPMOUNTDIR="${BURNDIR}/mnt"
else
	echo "There is no '${CONFFILE}'" 1>&2		
	echo "That is the file where BashBurn stores its settings."
	echo "You must run the BashBurn installation script first as root to install"
	echo "all needed files. Do that now and then start 'bashburn' again."
	exit 1
fi

#Check if $BURNDIR exists, and if you have write perms.

if [ ! -e "${BURNDIR}" ]; then                    #If temporary directory does not exist, create it  
       	echo
	echo "Directory for temporary files does not exist. Attempting to create it." 
	if mkdir "${BURNDIR}"; then		# An user has usually write permission for the /tmp-dir.
		echo "'$BURNDIR' created succesfully!"
       		echo "Configure BashBurn before attempting to burn."
		sleep 3s
	else
		echo "You do not have write permission for '$BURNDIR'" 1>&2
		echo "Change this value in config or you will not be able to burn anything."
		wait_for_enter
	fi
fi

if [ ! -e "$ROOTDIR" ]; then
	echo "The directory ($ROOTDIR) doesn't exist, although you wrote it" \
	     "into the configfile ('${CONFFILE}')" 1>&2
	exit 1
fi

####PROGRAM START####
while true; do
	# <colors>
	COLOROFF="\033[1;0m"	# standart color
	HEADCOLOR="\033[1;32m"	# green
	MAINCOLOR="\033[1;37m"	# white
	SUBCOLOR="\033[1;36m"	# blue
	TABLECOLOR="\033[1;31m"	# red
	INPUTCOLOR="\033[1;35m"	# lilac
	# </colors>
	setterm -clear
	# <table>
	echo -e "${TABLECOLOR}${DECOLINE}"
	echo -e "${TABLECOLOR}|${HEADCOLOR} ${VERSION} ${TABLECOLOR}|"
	echo -e "${TABLECOLOR}${DECOLINE}"
	echo -e "${TABLECOLOR}|" 
	echo -e "${TABLECOLOR}|-(${SUBCOLOR}MAIN${TABLECOLOR})"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 1) Audio"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 2) Data"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 3) ISO"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 4) Bin/Cue"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 5) Multisession"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 6) Blank CD-RW"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 7) Configure"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 8) View ${BURNDIR}"
        echo -e "${TABLECOLOR}|${MAINCOLOR} 9) Clear ${BURNDIR}"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 10) Mount/Unmount CD"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 0) Exit"
	echo -e "${TABLECOLOR}|"
	echo -n -e "${INPUTCOLOR}Your Choice? [0-10] |>${MAINCOLOR} "
	read action
	echo -e "$COLOROFF"
	# </table>
	
	case $action in
  		1)	# If you chose audio, do:
			variable_reader
			${ROOTDIR}/menus/audio_menu.sh 	      	# The audio menu
			continue
		;;
		2) 	# If you chose data, do:
                        variable_reader
			${ROOTDIR}/menus/data_menu.sh			# The data menu
			continue
  		;;
		3)	#If you chose ISO, do:
			${ROOTDIR}/menus/iso_menu.sh			# The ISO menu 
  			continue
		;;
		4)
			#Burn an bin/cue file:
			${ROOTDIR}/burning/bincue.sh
		;;
  		5)	#Multisession - Alrighty then...
			${ROOTDIR}/burning/multi.sh			# The multisession menu
			continue
		;;
		6)	#If you chose to blank CDRW:
			echo "Blanking cd..."
			if cdrecord -v dev=${CDWRITER} blank=${BLANKING} speed=${SPEED} ;then	#Blanking CDRW
				echo "CDRW blanked"
				wait_for_enter				# Wait for confirmation
			else
				echo "Plain blanking failed. Trying to force..."
				if cdrecord -v dev=${CDWRITER} blank=${BLANKING} speed=${SPEED} -force 1>/dev/null; then	#Forced blanking
					echo "Forced blanking succeeded."
					wait_for_enter
				else
					echo "Blanking was not successful. You should replace this cd." 1>&2
					wait_for_enter
				fi
			fi
			sleep 2s				# wait two seconds
			continue 			    	# Back to menu
  		;;
  		7)	# If you chose to configure BashBurn:
			variable_reader				# Read all variables again. Just to make sure...
			${ROOTDIR}/config/configure.sh			# Configure menu
			variable_reader				# Read in vars again
			continue
		;;
		8)
			echo "Contents of ${BURNDIR}"; echo	
			ls -lhgGL --color ${BURNDIR}		# View files in the BURNDIR
			wait_for_enter

		;;
  		9)	# to clear/remove files in the temporary burn-dir (e.g. /tmp/burn)
			while true; do
				echo "Do you really want to erase all files in ${BURNDIR}? (yes/no)"
				echo -n "|> "
				read temp
				if [ $temp = "yes" ]; then
					rm -rf ${BURNDIR}/*
					echo "${BURNDIR} is cleared."
					sleep 2s
					break
				else
					echo "Deletion cancelled"
					sleep 2s
					break
				fi
			done
  		;;
		10)	# Mount/unmount a cd
			${ROOTDIR}/misc/mount.sh
			continue
		;;
 		0)	# Traitor! You quit BashBurn!
			echo -e "${MAINCOLOR}Thank you for using ${HEADCOLOR}${VERSION}"
			echo -e "${MAINCOLOR}Visit ${SUBCOLOR}http://bashburn.sf.net${MAINCOLOR} for info and updates.${COLOROFF}"
			sleep 2s
			break
  		;;
  		*)	# You actually chose wrong? ...hmmm...
			echo "Please choose 0 - 10. Not that hard" 1>&2  
			sleep 1s
			continue				#Else go to menu
  		;;
	esac
done
