MYSHELL='which bash'


#!${MYSHELL}
# |====================|=============================|
# | filename           | Install.sh                  |
# | original author    | Anders Lindn               |
# | initial date       | Late (?) 2002               |
# |====================|=============================|
# | last changed       | 030203                      |
# | changes by         | Anders Lindn               |
# |====================|=============================|
# | description        | This is the install script  |
# |====================| of BashBurn. It replaces the|
# | old sometimes a bit tricky way of installing     |
#  BashBurn  with a simple script that does the     |
# | work for you. :-)                                |
# |==================================================|

CONFFILE=/etc/bashburnrc
ROOTDIR=$(pwd)

overwrite_selection()
{
while true; do
	echo "(y/n)"
	read choice
	if [ "$choice" = "n" ]; then
		exit
	else
		break
	fi
done
}


echo
echo "Installation script for BashBurn 1.3+"
echo

if whoami | grep root > /dev/null ; then
	echo "Creating link 'bashburn' in /usr/local/bin"
        cd /usr/local/bin && ln -sf ${ROOTDIR}/BashBurn.sh bashburn
	if [ -e ${CONFFILE} ]; then
		echo "Config file found! (${CONFFILE}) Do you want to overwrite it?"
		overwrite_selection
		echo "Installing config file..."
		cp -f ${ROOTDIR}/bashburnrc ${CONFFILE} 
		cat ${CONFFILE} | sed -e "s^ROOTDIR.*ROOTDIR: $ROOTDIR" | cat &> ${CONFFILE}
	else
		echo "Installing config file..."
		cp -f ${ROOTDIR}/bashburnrc ${CONFFILE}
		cat ${CONFFILE} | sed -e "s^ROOTDIR.*ROOTDIR: $ROOTDIR" | cat &> ${CONFFILE}
	fi
	echo "BashBurn config file and link installed."
	echo; echo "Do you want regular users to be able to change the global config file?"
	echo "NOTE: On small systems (Say a computer you and your family uses) this"
	echo "might be a good idea."
	overwrite_selection
	chmod 666 ${CONFFILE}
else
	echo "You are not root. Please run this script as root before starting BashBurn"
fi


