MYSHELL='which bash'
#!${MYSHELL}

# A function that waits for the enter key to be pressed
wait_for_enter()
{
while true; do
        echo "Press [ENTER] to return to main menu."
        read temp
        if [ "$temp" = "" ]; then
                break
        else
                continue
        fi
done
}

# Another wait function
wait_to_cont()
{
while true; do
	echo "Press [ENTER] to continue."
	read temp
	if [ "$temp" = "" ]; then
		break
	else
		continue
	fi
done
}


#This is the function that burns the cd
burn_multi()
{
if [ "$(find ${BURNDIR} -iname '*iso' | sort)" != "" ]; then		#Check if ISO exists in BURNDIR
	echo "ISO found..."
	echo "  if this is NOT the first burn to a multisession CD"
	echo "  then this ISO *MUST* have been created using valid previous session offset params"
	echo "  Why: because this session will be invisible and useless otherwise"
	wait_to_cont
	cdrecord dev=${CDWRITER} speed=${SPEED} ${OPT_ONE:+"driveropts=$OPT_ONE"} \
       	${MULTI} -eject -v ${BURNDIR}/*.iso		#If it does, burn it
	echo "CD burned..."
	wait_for_enter
else
	echo " No ISO found, trying to create one..."	#If not...
	sleep 2s
	if [ ${GET_PREV_SESSION} != 0 ]; then
		echo; echo; echo "Obtaining previous session offset data using -msinfo"
		MSINFODATA=`cdrecord dev=${CDWRITER} -msinfo`
		echo; echo "msinfo info needed for multisession is: [$MSINFODATA]"
		echo "if brackets [${MSINFODATA}] have two numbers with a comma - ALL IS GOOD TO GO!"
		if [ ${MSINFODATA} == "" ]; then
			echo "an error message ending with: \"cdrecord: Cannot read session offset\" means a virgin CD blank"
			echo "an error message ending with: \"cdrecord: No disk / Wrong disk!\" means no disk in drive"
			MKISO_CM_ARGS=""
			wait_to_cont
		else
			MKISO_CM_ARGS="-C ${MSINFODATA} -M ${CDWRITER}"
			echo; echo "got valid multisession data, adding args: ${MKISO_CM_ARGS}"
			sleep 2s
		fi
	else
		# first burn to multisession CD does not need -msdata info
		echo; echo; echo "First burn to multisession CD does not need previous session offset data"
		MKISO_CM_ARGS=""
		sleep 2s
	fi
	
	echo; echo "now, make the ISO if possible..."
	sleep 2s
	if eval "mkisofs -r -T -f -v -J -hide-joliet-trans-tbl -copyright \"$COPYRIGHT\" \
		-A \"$DESCRIPTION\" -p \"$AUTHOR\" -P \"$PUBLISHER\" \
		-volset \"$NAMEOFPACKAGE\" -volset-size \"$NUMBEROFCDS\" \
		-volset-seqno \"$CURRENTNUMBER\" -V \"$LABEL\" $MKISO_CM_ARGS \
		-o $BURNDIR/BashBurn.iso $BURNDIR"; then 
		echo "ISO created"
		#Files existed, ISO created
		cdrecord dev=$CDWRITER speed=$SPEED ${OPT_ONE:+"driveropts=$OPT_ONE"} \
		 $MULTI -eject -v ${OBURN} $BURNDIR/*.iso                #Burn the created ISO
		echo "CD burned..."
		wait_for_enter
	else
		echo "Error: Could not create an iso-file." 1>&2	#Something went wrong
		echo "Maybe... No files in ${BURNDIR}" 1>&2	#BURNDIR was empty, copy files here first
		echo "Maybe you dont have write permissions?" 1>&2
		wait_for_enter
	fi
fi	
	
}

#####PROGRAM START#####
while true; do
	# <colors>
	COLOROFF="\033[1;0m"	# standard color
	HEADCOLOR="\033[1;32m"	# green
	MAINCOLOR="\033[1;37m"	# white
	SUBCOLOR="\033[1;36m"	# blue
	TABLECOLOR="\033[1;31m"	# red
	INPUTCOLOR="\033[1;35m"	# lilac
	# </colors>
	setterm -clear
	# <table>
        echo -e "${TABLECOLOR}${DECOLINE}"
        echo -e "${TABLECOLOR}|${HEADCOLOR} ${VERSION} ${TABLECOLOR}|"
        echo -e "${TABLECOLOR}${DECOLINE}"
	echo -e "${TABLECOLOR}|"
	echo -e "${TABLECOLOR}|-(${SUBCOLOR}Multisession CD${TABLECOLOR})"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 1) First burn to a Multisession CD"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 2) Continue Multisession CD"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 3) Finish Multisession CD"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 0) Back"
	echo -e "${TABLECOLOR}|"
	echo -n -e "${INPUTCOLOR}>${MAINCOLOR} "
	read action
	echo -e "$COLOROFF"


case $action in
  		1)				# Starting multisession CD, first burn
			MULTI="-multi"		#We need to add this to cdrecord
			GET_PREV_SESSION=0	# first burn there is no previous session data
			burn_multi		#Call function above
			break			#Return to main		
  		;;
  		2)				# Continuing multisession CD
			MULTI="-multi"		#We need to add this to cdrecord
			GET_PREV_SESSION=1	# anytime after first burn we need previous session -msinfo data
			burn_multi		#Call function above
			break			#Return to main		
  		;;
  		3)				#Finishing multisession
			MULTI=""		#-multi cannot be added			
			GET_PREV_SESSION=1	# anytime after first burn we need previous session -msinfo data
			burn_multi		#Call function above
			break			#Return to main
		;;
  		0)				#Aborting
   			echo "Back to menu.."
   			break			#Back to main
   		;;
   		*)				#You entered a bad number
			echo "0 - 3 please..."
			sleep 2s
   			continue
   		;;
	esac

done
