MYSHELL='which bash'
#!${MYSHELL}

#Variables that BashBurn use
variable_reader()
{
	export ROOTDIR="$( cat $CONFFILE | grep -v '^#' | grep ROOTDIR:  | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]//g")"
	export ROOTDIR="${ROOTDIR%*/}"
	export CDROM="$(   cat $CONFFILE | grep -v '^#' | grep CDROM:    | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]//g")" 
	export CDWRITER="$(cat $CONFFILE | grep -v '^#' | grep CDWRITER: | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]//g")"
	export SPEED="$(   cat $CONFFILE | grep -v '^#' | grep SPEED:    | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]//g")"
	export BLANKING="$(cat $CONFFILE | grep -v '^#' | grep BLANKING: | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]//g")"
	export NUMDEV="$(  cat $CONFFILE | grep -v '^#' | grep NUMDEV:   | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]//g")"
	export BURNDIR="$( cat $CONFFILE | grep -v '^#' | grep BURNDIR:  | cut -d ":" -f 2- | sed -e "s/^[[:blank:]]//g")"
        export BURNDIR="${BURNDIR%*/}"
	
	# additional informations of a CD:
	export LABEL="$( cat $CONFFILE 		| grep -v '^#' 	| grep LABEL:  		| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export COPYRIGHT="$( cat $CONFFILE 	| grep -v '^#' 	| grep COPYRIGHT:  	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export DESCRIPTION="$( cat $CONFFILE 	| grep -v '^#' 	| grep DESCRIPTION:  	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export AUTHOR="$( cat $CONFFILE 	| grep -v '^#'	| grep AUTHOR:  	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export PUBLISHER="$( cat $CONFFILE 	| grep -v '^#'	| grep PUBLISHER:	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export NAMEOFPACKAGE="$( cat $CONFFILE 	| grep -v '^#'| grep NAMEOFPACKAGE:   	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export NUMBEROFCDS="$( cat $CONFFILE 	| grep -v '^#'  | grep NUMBEROFCDS:	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export CURRENTNUMBER="$( cat $CONFFILE 	| grep -v '^#'| grep CURRENTNUMBER:	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"

	export NORMALIZE="$( cat $CONFFILE 	| grep -v '^#'| grep NORMALIZE:   	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export OPT_ONE="$(   cat $CONFFILE 	| grep -v '^#'| grep OPT_ONE:   	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export FIFODIR="$(   cat $CONFFILE 	| grep -v '^#'| grep FIFODIR:   	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export DELTEMPBURN="$(   cat $CONFFILE 	| grep -v '^#'| grep DELTEMPBURN:	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export OVERBURN="$(   cat $CONFFILE 	| grep -v '^#'| grep OVERBURN:     	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
	export COPY_PROTECT="$(   cat $CONFFILE     | grep -v '^#'| grep COPY_PROTECT:	| cut -d ":" -f 2- | sed -e "s/^[[:blank:]]*//g")"
}

#####PROGRAM START#####
while true; do
	# <colors>
	COLOROFF="\033[1;0m"	 # standard color
	HEADCOLOR="\033[1;32m"	 # green
	MAINCOLOR="\033[1;37m"	 # white
	SUBCOLOR="\033[1;36m"	 # blue
	TABLECOLOR="\033[1;31m"	 # red
	INPUTCOLOR="\033[1;35m"	 # lilac
	OPTIONCOLOR="\033[1;33m" # yellow
	# </colors>
	setterm -clear
	# <table>
        echo -e "${TABLECOLOR}${DECOLINE}"
        echo -e "${TABLECOLOR}|${HEADCOLOR} ${VERSION} ${TABLECOLOR}|"
        echo -e "${TABLECOLOR}${DECOLINE}"
	echo -e "${TABLECOLOR}|" 
	echo -e "${TABLECOLOR}|-(${SUBCOLOR}Setup${TABLECOLOR})\t\t\t${TABLECOLOR}(${SUBCOLOR}CURRENT VALUE${TABLECOLOR})"
	echo -e "${TABLECOLOR}|${MAINCOLOR}  1) CD-Writer\t\t\t(${OPTIONCOLOR}$CDWRITER${MAINCOLOR})"
	echo -e "${TABLECOLOR}|${MAINCOLOR}  2) CD-Reader\t\t\t(${OPTIONCOLOR}$CDROM${MAINCOLOR})"
	echo -e "${TABLECOLOR}|${MAINCOLOR}  3) Speed\t\t\t(${OPTIONCOLOR}$SPEED${MAINCOLOR})"
	echo -e "${TABLECOLOR}|${MAINCOLOR}  4) Blanking Type\t\t(${OPTIONCOLOR}$BLANKING${MAINCOLOR})"
	echo -e "${TABLECOLOR}|${MAINCOLOR}  5) Number of Devices\t\t(${OPTIONCOLOR}$NUMDEV${MAINCOLOR})"
	echo -e "${TABLECOLOR}|${MAINCOLOR}  6) Root Directory\t\t(${OPTIONCOLOR}$ROOTDIR${MAINCOLOR})"
	echo -e "${TABLECOLOR}|${MAINCOLOR}  7) Burn Directory\t\t(${OPTIONCOLOR}$BURNDIR${MAINCOLOR})" 
	echo -e "${TABLECOLOR}|${MAINCOLOR}  8) CD Label\t\t\t(${OPTIONCOLOR}$LABEL${MAINCOLOR})" 
	echo -e "${TABLECOLOR}|${MAINCOLOR}  9) Copyright\t\t\t(${OPTIONCOLOR}$COPYRIGHT${MAINCOLOR})" 
	echo -e "${TABLECOLOR}|${MAINCOLOR} 10) Author\t\t\t(${OPTIONCOLOR}$AUTHOR${MAINCOLOR})" 
	echo -e "${TABLECOLOR}|${MAINCOLOR} 11) Publisher\t\t\t(${OPTIONCOLOR}$PUBLISHER${MAINCOLOR})" 
	echo -e "${TABLECOLOR}|${MAINCOLOR} 12) Description\t\t(${OPTIONCOLOR}$DESCRIPTION${MAINCOLOR})" 
	echo -e "${TABLECOLOR}|${MAINCOLOR} 13) Name of the package\t(${OPTIONCOLOR}$NAMEOFPACKAGE${MAINCOLOR})" 
	echo -e "${TABLECOLOR}|${MAINCOLOR} 14) Number of all CDs\t\t(${OPTIONCOLOR}$NUMBEROFCDS${MAINCOLOR})" 
	echo -e "${TABLECOLOR}|${MAINCOLOR} 15) Current Number of the CD\t(${OPTIONCOLOR}$CURRENTNUMBER${MAINCOLOR})" 
	
	echo -e "${TABLECOLOR}|${MAINCOLOR} 16) Normalize\t\t\t(${OPTIONCOLOR}$NORMALIZE${MAINCOLOR})"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 17) Driver options\t\t(${OPTIONCOLOR}$OPT_ONE${MAINCOLOR})"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 18) FIFO directory\t\t(${OPTIONCOLOR}$FIFODIR${MAINCOLOR})"	
	echo -e "${TABLECOLOR}|${MAINCOLOR} 19) Delete temp after burn\t(${OPTIONCOLOR}$DELTEMPBURN${MAINCOLOR})"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 20) Allow overburn\t\t(${OPTIONCOLOR}$OVERBURN${MAINCOLOR})"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 21) Copy protection\t\t(${OPTIONCOLOR}$COPY_PROTECT${MAINCOLOR})"

	echo -e "${TABLECOLOR}|${MAINCOLOR} 22) Apply changes"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 23) Apply defaults"
	echo -e "${TABLECOLOR}|${MAINCOLOR}  0) Back"
	echo -e "${TABLECOLOR}|"
	echo -n -e "${INPUTCOLOR}>${MAINCOLOR} "
	read action
	echo -e "${COLOROFF}"
	# </table>

	case $action in
  		1)					#Change writer device
			echo
			echo -e "${OPTIONCOLOR}The burner is supposed to be entered as 0,0,0 (For SCSI)"
			echo -e "${OPTIONCOLOR}ATAPI:0,0,0 or hdX (For IDE burners)"
			echo -e "${OPTIONCOLOR}(Where hdX is the proper drive, like hdc)"
			echo -e "${COLOROFF}"
			echo -e "${MAINCOLOR}(Possible) SCSI DEVICES:"
			echo -e "${COLOROFF}"
			cdrecord -scanbus
			echo
			echo -e "${MAINCOLOR}(Possible) IDE DEVICES:"
			echo -e "${COLOROFF}"
			cdrecord dev=ATAPI -scanbus
   			echo
			echo -n "Enter path to burner: "   
   			read CDWRITER
  			continue 
   		;;	
 		2)					#Change cdrom device
   			echo
			echo -e "${OPTIONCOLOR}"
			echo "Path to reader is usually something like /mnt/cdrom or /mnt/dvd"
			
			if cat /etc/fstab | grep cdrom &> /dev/null; then
			echo
			
			echo "List of possible cdrom drives (According to /etc/fstab): "
			echo -e "${SUBCOLOR}"
			echo
				cat /etc/fstab | grep cdrom && cat /etc/fstab | grep dvd
			fi				
			echo -e "${COLOROFF}"
			echo -n "Enter path to cd reader: "
   			read CDROM
   			continue
   		;;
  		3)					#Change writer speed
			echo
   			echo -n "Enter speed of burner: "
   			read SPEED
   			continue
   		;;
	 	4)					#Change type of blanking
			echo
			echo -e "${OPTIONCOLOR}Enter type of blanking. Default is 'all' or 'disc'"
			echo -e "${COLOROFF}"
   			cdrecord blank=help
   			echo -n "|> "
   			read BLANKING
   			continue
   		;;
  		5)					#Number of devices
   			echo "Do you have both a cdreader and cdwriter?"  #Well...do you?
   			echo "If so, enter 2. If not, enter 1"
			echo -n "|> "
   			read NUMDEV
   			continue
   		;;
  		6)					#Change of ROOTDIR. Be careful!
			echo "Root directory is the directory where all of BashBurn's shellscripts are."
			echo "Only change it if you know what you are doing."
			echo -e "If you want to cancel just enter ${OPTIONCOLOR}${ROOTDIR}${COLOROFF} at the prompt."
			echo "(${ROOTDIR} is the current root directory)"
			echo -n "|> "
			read ROOTDIR
		;;
		7)					#Change of BURNDIR. Default usually ok.
			echo "Burn directory is where you put/link the files to be burned. Be sure to have"
			echo "write permissions to this directory."
			echo -e "If you want to cancel just enter ${OPTIONCOLOR}${BURNDIR}${COLOROFF} at the prompt."
			echo "(${BURNDIR} is the current burn directory)"
			echo -n "|> "
			read BURNDIR
		;;			
		8)					#Label of the cd	
			echo "Enter the wanted Label of the CD:"
			echo -n "|> "
			read LABEL
		;;					
		9)					#Copyright notice (If any)	
			echo "If you want to set a copyright on you CD, enter it now:"
			echo -n "|> "
			read COPYRIGHT
		;;
		10)					#Author
			echo "Enter the Autor/Owner of the CD - ey, that's you, isn't it?"
			echo -n "|> "
			read AUTHOR
		;;
		11)					#Publisher
			echo "Enter the Publisher of the CD (if there is one):"
			echo -n "|> "
			read PUBLISHER
		;;
		12)					#Content decription
			echo "Describe the content of the CD:"
			echo -n "|> "
			read DESCRIPTION
		;;
		13)					#Name of package
			echo "Enter the name of the package:"
			echo "(a package consists of several CDs)"
			echo -n "|> "
			read NAMEOFPACKAGE
		;;
		14)					#Number of cds
			echo "How many CDs are in the package?"
			echo -n "|> "
			read NUMBEROFCDS	
		;;
		15)					#Number of cd
			echo "What is the current number of the current CD you want to burn?"
			echo -n "|> "
			read CURRENTNUMBER
		;;
		16)					#Use normalize
			echo "Do you want to use normalize? (Adjust the volume of Mp3 or wav files.)"
   			echo "Only enter yes if you have the normalize program installed, otherwise say no."
   			echo -n "|>  "
   			read NORMALIZE
		;;
		17)					#Driver options
			echo -e "${OPTIONCOLOR}Enter the driver option(s) you would like to use, separate"
			echo "them with a comma. If unsure, just press enter without writing anything."
			echo "(You must have a CD in the drive for this detection to work)"
			echo -e "${COLOROFF}"
			cdrecord dev=$CDWRITER -checkdrive driveropts=help 
   			echo ""
			echo -n "|> "
   			read OPT_ONE
		;;
		18)					#FIFO dir for direct audio burning
			echo "Enter location of FIFO-directory. This is only needed for piped burning, and most times"
			echo -e "the standard value is fine. If you want to cancel just enter ${OPTIONCOLOR}${FIFODIR}${COLOROFF}"
			echo "at the prompt."
			echo "(${FIFODIR} is the current FIFO-directory)"
			echo -n "|> "
			read FIFODIR
		;;
		19)
			echo -e "Delete files in ${OPTIONCOLOR}${BURNDIR}${COLOROFF} after burn is complete?"
			echo "Default is no, which you should enter if you are going to burn those files more than once..."
			echo -n "|> "
			read DELTEMPBURN
		;;
		20)
			echo "Would you like BashBurn to allow overburn? Your burner must support it, and it is not"
			echo "certain that it will work anyways, since this might burn more onto the cd than it was"
			echo "designed for. Default is no. (yes/no)"
			echo -n "|> "
			read OVERBURN
		;;
		21)
			echo "This setting is for audio cds. Is the contents copy protected or not?"
			echo "Default is no."
			echo "NOTE: This option does not actually copy protect the audio files"
			echo "being burned, it just tells cdrecord to indicate if they are."
			echo -n "|> "
			read COPY_PROTECT
		;;
		22)					#Apply changes	
   			cat $CONFFILE | sed -e "s^CDWRITER.*CDWRITER: $CDWRITER" 			\
						 -e "s^CDROM.*CDROM: $CDROM" 	 		\
					  	 -e "s^SPEED.*SPEED: $SPEED"          		\
   						 -e "s^BLANKING.*BLANKING: $BLANKING" 		\
					  	 -e "s^NUMDEV.*NUMDEV: $NUMDEV"	 		\
						 -e "s^ROOTDIR.*ROOTDIR: $ROOTDIR"	 		\
   						 -e "s^BURNDIR.*BURNDIR: $BURNDIR"			\
						 -e "s^LABEL.*LABEL: $LABEL"				\
						 -e "s^COPYRIGHT.*COPYRIGHT: $COPYRIGHT"		\
						 -e "s^DESCRIPTION.*DESCRIPTION: $DESCRIPTION" 	\
						 -e "s^AUTHOR.*AUTHOR: $AUTHOR" 			\
						 -e "s^PUBLISHER.*PUBLISHER: $PUBLISHER" 		\
						 -e "s^NAMEOFPACKAGE.*NAMEOFPACKAGE: $NAMEOFPACKAGE" \
						 -e "s^NUMBEROFCDS.*NUMBEROFCDS: $NUMBEROFCDS"	\
						 -e "s^CURRENTNUMBER.*CURRENTNUMBER: $CURRENTNUMBER" \
						 -e "s^NORMALIZE.*NORMALIZE: $NORMALIZE" 		\
						 -e "s^OPT_ONE.*OPT_ONE: $OPT_ONE" 			\
						 -e "s^FIFODIR.*FIFODIR: $FIFODIR"			\
						 -e "s^DELTEMPBURN.*DELTEMPBURN: $DELTEMPBURN"	\
						 -e "s^OVERBURN.*OVERBURN: $OVERBURN"		\
						 -e "s^COPY_PROTECT.*COPY_PROTECT: $COPY_PROTECT"	| cat &> $CONFFILE
			if [ $? -eq 0 ]; then
				echo "Changes applied!"
   				sleep 2s
				variable_reader
				continue
   			else
				echo "Couldn't write into ${CONFFILE}!" 1>&2
				sleep 2s
				exit 1
			fi
		;;
		23)					#Apply default values
   			CDWRITER="0,0,0"
   			CDROM="/dev/cdrom"
   			SPEED="20"
   			BLANKING="all"
   			NUMDEV="1"
			BURNDIR="/tmp/burn"
			LABEL="not set"
   			COPYRIGHT="not set"
			AUTHOR="not set"
			PUBLISHER="not set"
			DESCRIPTION="not set"
			NAMEOFPACKAGE="not set"
			NUMBEROFCDS="1"
			CURRENTNUMBER="1"

			NORMALIZE="no"
			OPT_ONE=
			FIFODIR="/tmp"
			DELTEMPBRUN="no"
			OVERBURN="no"
			COPY_PROTECT="no"

			cat $CONFFILE | sed -e "s^CDWRITER.*CDWRITER: $CDWRITER" 		\
						 -e "s^CDROM.*CDROM: $CDROM" 	 		\
					  	 -e "s^SPEED.*SPEED: $SPEED"          		\
   						 -e "s^BLANKING.*BLANKING: $BLANKING" 		\
					  	 -e "s^NUMDEV.*NUMDEV: $NUMDEV"	 		\
						 -e "s^ROOTDIR.*ROOTDIR: $ROOTDIR"	 		\
   						 -e "s^BURNDIR.*BURNDIR: $BURNDIR"			\
						 -e "s^LABEL.*LABEL: $LABEL"				\
						 -e "s^COPYRIGHT.*COPYRIGHT: $COPYRIGHT"		\
						 -e "s^DESCRIPTION.*DESCRIPTION: $DESCRIPTION" 	\
						 -e "s^AUTHOR.*AUTHOR: $AUTHOR" 			\
						 -e "s^PUBLISHER.*PUBLISHER: $PUBLISHER" 		\
						 -e "s^NAMEOFPACKAGE.*NAMEOFPACKAGE: $NAMEOFPACKAGE" \
						 -e "s^NUMBEROFCDS.*NUMBEROFCDS: $NUMBEROFCDS"	\
						 -e "s^CURRENTNUMBER.*CURRENTNUMBER: $CURRENTNUMBER" \
						 -e "s^NORMALIZE.*NORMALIZE: $NORMALIZE" 		\
						 -e "s^OPT_ONE.*OPT_ONE: $OPT_ONE" 			\
						 -e "s^FIFODIR.*FIFODIR: $FIFODIR"			\
						 -e "s^DELTEMPBURN.*DELTEMPBURN: $DELTEMPBURN"       \
						 -e "s^OVERBURN.*OVERBURN: $OVERBURN"		\
						 -e "s^COPY_PROTECT.*COPY_PROTECT: $COPY_PROTECT"	| cat &> $CONFFILE
			if [ $? -eq 0 ]; then
				echo "Defaults applied!"
				echo "(ROOTDIR has *no* default - you have to change it!)"
   				sleep 3s
				variable_reader
   				continue
   			else
				echo "Couldn' write into ${CONFFILE}!" 1>&2
				exit 1
			fi
		;;
  		0)					#Back to main menu
   			echo "Back to menu"
  			break
		;;
  		*)					#You entered a bad number
   			echo "0 - 23 please..."
			sleep 1s
			continue
  		;;
 	esac
done
