MYSHELL='which bash'
#!${MYSHELL}

# A little wait function
wait_for_enter()
{
while true; do
	echo "Press [ENTER] to return to main menu."
	read temp
	if [ "$temp" = "" ]; then
		break
	else
		continue
	fi
done
}

#This function lets you swap cds if you only have one device.
#(CDwriter and CDreader is same device.)
insert_new_CD()
{
        while true; do
                echo "Insert blank cd and then press enter to go on"
                read temp
                if [ "$temp" = "" ]; then
                        break
                else
                        continue
                fi
        done
}

# A little function that looks for mp3s

check_for_mp3s()
{
	cd ${BURNDIR}
	while read MPTHREE; do
        	existing="yes"
	done < <(find ${BURNDIR} -iname "*mp3" | sort)

	if [ "$existing" != "yes" ]; then
        	echo
        	echo "No Mp3s in ${BURNDIR}" 1>&2
	else
		${ROOTDIR}/convert/convert_mp3s.sh
	fi
}

# A function that checks for ogg files

check_for_oggs()
{
	cd ${BURNDIR}
	while read OGGS; do
		existing="yes"
	done < <(find ${BURNDIR} -iname "*ogg" | sort)

	if [ "$existing" != "yes" ]; then
        	echo
        	echo "No Oggs in ${BURNDIR}" 1>&2
	else
		${ROOTDIR}/convert/convert_oggs.sh	
	fi
}

####PROGRAM START#####

while true; do
        # <colors>
        COLOROFF="\033[1;0m"    # standart color
        HEADCOLOR="\033[1;32m"  # green
        MAINCOLOR="\033[1;37m"  # white
        SUBCOLOR="\033[1;36m"   # blue
        TABLECOLOR="\033[1;31m" # red
        INPUTCOLOR="\033[1;35m" # lilac
        # </colors>   
        setterm -clear
        # <table>
        echo -e "${TABLECOLOR}${DECOLINE}"
        echo -e "${TABLECOLOR}|${HEADCOLOR} ${VERSION} ${TABLECOLOR}|"
        echo -e "${TABLECOLOR}${DECOLINE}"
        echo -e "${TABLECOLOR}|"
        echo -e "${TABLECOLOR}|-(${SUBCOLOR}Audio Menu${TABLECOLOR})"
        echo -e "${TABLECOLOR}|${MAINCOLOR} 1) Burn Audio from Mp3s/Oggs/Wavs"
        echo -e "${TABLECOLOR}|${MAINCOLOR} 2) Burn Audio Directly"
        echo -e "${TABLECOLOR}|${MAINCOLOR} 3) Copy Audio CD (CD to CD)"
        echo -e "${TABLECOLOR}|${MAINCOLOR} 4) Copy Audio CD (CD to harddrive)"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 5) Burn Xmms Playlist"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 6) Create Mp3s from Wavs"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 7) Create Oggs from Wavs"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 8) Create Mp3s from CD"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 9) Create Oggs from CD"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 0) Back"
        echo -e "${TABLECOLOR}|"
        echo -n -e "${INPUTCOLOR}>${MAINCOLOR} "
        read action
        echo -e "$COLOROFF"
        # </table>

 case $action in
                1)      
			# Burn Audio from Mp3s
                        	check_for_mp3s                  # Converting mp3s to wavs
				check_for_oggs			# Converting oggs to wavs
                                ${ROOTDIR}/burning/burning.sh --audio
				sleep 2s
	        ;;
                2)      
			# Burn Audio Directly
			${ROOTDIR}/burning/burning.sh --pipeline
			sleep 2s
                ;;
                3)	
			# Copy an audio cd.
			cd ${BURNDIR}
                        if cdda2wav -D ${CDROM} -v all -B -Owav; then      #Changed from cdparanoia to cdda2wav
                        	eject ${CDROM}
                                echo "Tracks ripped!"
                                if [ ${NUMDEV} == 1 ]; then                     #Check number of devices
                        	        insert_new_CD
                                fi
                                     
				if cdrecord -v dev=${CDWRITER} speed=${SPEED} \
					${OPT_ONE:+"driveropts=$OPT_ONE"} -dao \
					-useinfo ${BURNDIR}/*.wav; then
                                        echo "Burning complete - Thanks for using BashBurn"
                                        wait_for_enter
                                else
                                        echo "Error occurred! Couldn't burn the CD." 1>&2
                                        wait_for_enter
				fi
                        else
                                echo "Error occurred! Couldn't rip the tracks from ${CDROM}." 1>&2
                                wait_for_enter
			fi
       		;;
                4)      
			# Copy an audio cd to HD
			cd ${BURNDIR}
                        cdda2wav -D ${CDROM} -v all -B -Owav
                        eject ${CDROM}
                        echo "Tracks ripped and stored in ${BURNDIR}. If you want to create"
			echo "mp3s or oggs, use the respective function from the menu."
                        wait_for_enter                
                ;;
		5)	
			# Burn a xmms playlist
			if eval ${ROOTDIR}/misc/xmmsread.sh; then
				${ROOTDIR}/burning/burning.sh --audio
			else
				echo "Read of playlist failed. Not attempting to burn."
				wait_for_enter
			fi
		;;
		6)
			#Create Mp3s from Wavs in BURNDIR
			cd ${BURNDIR}
			
			while read WAV; do
        		echo
			if lame --preset cd "${WAV}" "${WAV%%.wav}.mp3"; then
				echo "${WAV%%.wav}.mp3 created..."
			else
				echo "${WAV}: couldn't be compressed" 1>&2
        		fi
        		echo
        		existing="yes"
			done < <(find "${BURNDIR}" -iname "*wav" | sort)

			if [ "$existing" != "yes" ]; then
        			echo
        			echo "No Wavs in ${BURNDIR}" 1>&2	
			fi

			sleep 2s
			continue
		;;
		7)
			#Create Oggs from Wavs in BURNDIR
                        cd ${BURNDIR}

                        while read WAV; do
                        echo
                        if oggenc -q 5 "${WAV}"; then
                                echo "File created..."
                        else
                                echo "${WAV}: couldn't be compressed" 1>&2
                        fi
                        echo
                        existing="yes"
                        done < <(find "${BURNDIR}" -iname "*wav" | sort)

                        if [ "$existing" != "yes" ]; then
                                echo
                                echo "No Wavs in ${BURNDIR}" 1>&2
                        fi

                        sleep 2s
                        continue
		;;
		8)
			# Create Mp3s from an audio cd.
			#First, rip the tracks
                        cd ${BURNDIR}
                        if cdda2wav -D ${CDROM} -v all -B -Owav; then      #Changed from cdparanoia to cdda2wav
                                eject ${CDROM}
                                echo "Tracks ripped!"
 				sleep 2s
			fi
			
			#Now create the Mp3s
			
			while read WAV; do
                        echo
                        
			if lame --preset cd ${WAV} ${WAV%%.wav}.mp3; then
                                echo "${WAV%%.wav}.mp3 created..."
                        else
                                echo "${WAV}: couldn't be compressed" 1>&2
                        fi
                        echo
                        existing="yes"
                        done < <(find "$BURNDIR" -iname "*wav" | sort)
			
			if [ "$existing" != "yes" ]; then
                                echo
                                echo "No Wavs in ${BURNDIR}" 1>&2
                        	sleep 2s
				continue
			fi
			
			echo "Mp3s created. Files are located under ${BURNDIR}"
                        rm ${BURNDIR}/*.wav
			rm ${BURNDIR}/*.inf
			wait_for_enter
		;;
		9)
			# Create Oggs from an audio cd.
                        #First, rip the tracks
                        
			cd ${BURNDIR}
                        
			if cdda2wav -D ${CDROM} -v all -B -Owav; then
                                eject ${CDROM}
                                echo "Tracks ripped!"
                                sleep 2s
                        fi
			
			#Now create the Oggs.
			
			while read WAV; do
                        echo
                        if oggenc -q 5 "${WAV}"; then
                                echo "File created..."
                        else
                                echo "${WAV}: couldn't be compressed" 1>&2
                        fi
                        echo
                        existing="yes"
                        done < <(find "${BURNDIR}" -iname "*wav" | sort)

                        if [ "$existing" != "yes" ]; then
                                echo
                                echo "No Wavs in ${BURNDIR}" 1>&2
                        	sleep 2s
				continue
			fi

			echo "Oggs created. Files are located under ${BURNDIR}"
			rm ${BURNDIR}/*.wav
			rm ${BURNDIR}/*.inf
                        wait_for_enter
		;;
		0)      # Abort
                        echo "Returning to main menu"
                        break
                ;;
                *)
                        echo "Please choose 0 - 9. Not that hard" 1>&2
                        sleep 1s
                        continue                                #Else go to menu
                ;;
        esac
done

