MYSHELL='which bash'
#!${MYSHELL}

# A small wait function
wait_for_enter()
{
while true; do
	echo "Press [ENTER] to return to menu."
	read temp
	if [ "$temp" = "" ]; then
		break
	else
		continue
	fi
done
}


####PROGRAM START#####
while true; do
        # <colors>
        COLOROFF="\033[1;0m"    # standart color
        HEADCOLOR="\033[1;32m"  # green
        MAINCOLOR="\033[1;37m"  # white
        SUBCOLOR="\033[1;36m"   # blue
        TABLECOLOR="\033[1;31m" # red
        INPUTCOLOR="\033[1;35m" # lilac
        # </colors>
        setterm -clear
        # <table>
        echo -e "${TABLECOLOR}${DECOLINE}"
        echo -e "${TABLECOLOR}|${HEADCOLOR} ${VERSION} ${TABLECOLOR}|"
        echo -e "${TABLECOLOR}${DECOLINE}"
        echo -e "${TABLECOLOR}|"
        echo -e "${TABLECOLOR}|-(${SUBCOLOR}ISO Menu${TABLECOLOR})"
        echo -e "${TABLECOLOR}|${MAINCOLOR} 1) Burn ISO"
        echo -e "${TABLECOLOR}|${MAINCOLOR} 2) Create ISO from files in $BURNDIR"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 3) Create ISO from cd"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 4) View ISO"
        echo -e "${TABLECOLOR}|${MAINCOLOR} 0) Back"
        echo -e "${TABLECOLOR}|"
        echo -n -e "${INPUTCOLOR}>${MAINCOLOR} "
        read action
        echo -e "$COLOROFF"
        # </table>

 case $action in
		1)      # Burn ISO
                        ${ROOTDIR}/burning/burning.sh --iso
                                break
                ;;
		2)	#Create ISO from BURNDIR
			
			if [ "$(find ${BURNDIR} -iname '*iso' | sort)" != "" ]; then			# Does an ISO file exist?
				echo "An ISO exists in ${BURNDIR}. Delete or move it"
				echo "before attempting to create a new one."
				wait_for_enter
				continue
			else			
						
			echo; echo "Trying to create ISO-file"          		#Creating ISO from files
                        if eval "mkisofs -r -T -f -v -J -hide-joliet-trans-tbl -copyright \"$COPYRIGHT\" \
				-A \"$DESCRIPTION\" -p \"$AUTHOR\" -P \"$PUBLISHER\" \
				-volset \"$NAMEOFPACKAGE\" -volset-size \"$NUMBEROFCDS\" \
				-volset-seqno \"$CURRENTNUMBER\" -V \"$LABEL\" \
				-o ${BURNDIR}/BashBurn.iso ${BURNDIR}"; then
                                echo "ISO created"
                                wait_for_enter
                                continue
                        else						#Some error occured
                                echo "Error: Could not create an iso-file." 1>&2
				echo "Maybe you don't have write permission?" 1>&2
                                wait_for_enter
				break
			fi
			
			fi

                ;;
		3)	#Create ISO from cd
			if [ "$(find ${BURNDIR} -iname '*iso' | sort)" != "" ]; then                    # Does an ISO file exist? 
                                echo "An ISO exists in ${BURNDIR}. Delete or move it"
                                echo "before attempting to create a new one."
                                wait_for_enter
                                break
                        else

			if [ $(find ${CDROM}/* -iname '*' | sort) == "" &> /dev/null ]; then                                      #No cd in drive?
                                echo "${CDROM} not mounted! Do that first..."
                                wait_for_enter
				continue
			else
                                echo "Creating ISO from cd in ${CDROM}"             
                                if mkisofs -o ${BURNDIR}/BashBurn.iso -f ${CDROM}; then	#Creating ISO using mkisofs
					echo "ISO created..."
					wait_for_enter
                                else
                                        echo "Error: Could not create an iso-file!" 1>&2
                                        echo "Maybe you don't have write permission?" 1>&2
					wait_for_enter
					break
				fi
                                sleep 2s                                        # Pause so you can see message
                                continue                                        # back to the menu
                        fi
			fi
		;;
		4)	#View an ISO
			${ROOTDIR}/misc/mount_loop.sh		#Call the script mount_loop
			continue
		;;
		0)      # Quit
                        echo "Returning to menu.."
                        break
                ;;
                *)	#You chose wrong stupid!
                        echo "Please enter 0-4. Not that hard."
                        sleep 1s
                        continue
                ;;
        esac
done
