MYSHELL='which bash'
#!${MYSHELL}

####PROGRAM START####
while true; do
	# <colors>
	COLOROFF="\033[1;0m"	# standart color
	HEADCOLOR="\033[1;32m"	# green
	MAINCOLOR="\033[1;37m"	# white
	SUBCOLOR="\033[1;36m"	# blue
	TABLECOLOR="\033[1;31m"	# red
	INPUTCOLOR="\033[1;35m"	# lilac
	# </colors>
	setterm -clear
	# <table>
        echo -e "${TABLECOLOR}${DECOLINE}"
        echo -e "${TABLECOLOR}|${HEADCOLOR} ${VERSION} ${TABLECOLOR}|"
        echo -e "${TABLECOLOR}${DECOLINE}"
	echo -e "${TABLECOLOR}|" 
	echo -e "${TABLECOLOR}|-(${SUBCOLOR}VIEW THE CONTENT OF AN ISO-FILE${TABLECOLOR})"
	a=0 							# variable of iteration
	while read i; do
		a=$[$a+1]					# increase the iteration-variable
		echo -e "${TABLECOLOR}|${MAINCOLOR} $a) $i"	# print for each found ISO-file a menu-entry
	done < <(find $BURNDIR -type f -name "*.iso")

	echo -e "${TABLECOLOR}|${MAINCOLOR} $[$a+1]) Apply"
	echo -e "${TABLECOLOR}|${MAINCOLOR} 0) Back"
	echo -e "${TABLECOLOR}|"
	echo -n -e "${INPUTCOLOR}>${MAINCOLOR} "
	read action
	echo -e "$COLOROFF"
	#</table>

	for i in `seq $a`; do					# '$a' is number of found ISO-files
		case $action in
  			$i)						
				x=0				# do as above
				while read o; do
					x=$[$x+1]
					if [ "$x" = "$action" ]; then
						ISOFILE="$o"	# In '$ISOFILE' save the name and the path of the ISO-file.
						ISOFILENAME="$(basename "$ISOFILE")"
						break		
					fi
				done < <(find $BURNDIR -type f -name "*.iso")

				# if '$TEMPMOUNTDIR' not exist, create it.
				# fi
				# if "${TEMPMOUNTDIR}" (e.g. /tmp/burn/mnt/BashBurn.iso) 
				# does not  exist, create it.
				if [ ! -e "${TEMPMOUNTDIR}/${ISOFILENAME}" ]; then
					mkdir "${TEMPMOUNTDIR}"
					mkdir "${TEMPMOUNTDIR}/${ISOFILENAME}"
				fi
				# if "${TEMPMOUNTDIR}/${ISOFILENAME}" is already mounted, umount it.
				if mount | grep -qie "${TEMPMOUNTDIR}/${ISOFILENAME}";  then
					umount "${TEMPMOUNTDIR}/${ISOFILENAME}"
				fi
				# mount the found ISO-file with the loopback-device 
				# into "${TEMPMOUNTDIR}/${ISOFILENAME}"
				if mount -o loop "$ISOFILE" "${TEMPMOUNTDIR}/${ISOFILENAME}"; then
					# if "${TEMPMOUNTDIR}/tmp" not exist, create it.
					if [ ! -e "${TEMPMOUNTDIR}/tmp" ]; then
						mkdir "${TEMPMOUNTDIR}/tmp"
					fi
					
					# Here's a bug before Magma 1.0 (snapshot: 20020207) because
					# there have to be trouble if you view more than one ISO at
					# the same time.
					# now it's fixed:
					if [ ! -e "${TEMPMOUNTDIR}/tmp/${ISOFILENAME}" ]; then
						mkdir "${TEMPMOUNTDIR}/tmp/${ISOFILENAME}"
					fi

					# copy all file from the mountpoint of the loopback-device into the
					# directory we created above. Why? A loopback-device is only readable,
					# but we need an writeable one, too.
					echo "Copying ISO - Please wait..."
					cp -a "${TEMPMOUNTDIR}/${ISOFILENAME}/"* "${TEMPMOUNTDIR}/tmp/${ISOFILENAME}/"
					
					# umount the loopback-device
					umount "${TEMPMOUNTDIR}/${ISOFILENAME}"
					echo "ISO-File was mounted in a loopback-device successfully."
					echo "At this prompt you can now do what you want with the ISO-file."
					echo "When you are finished, type exit to return to BashBurn."
					echo "If you modified something, then choose apply in the menu."
					echo "(If you don't want any changes to be applied, just select 'Back' in the menu)"
					# change into the created tmp-dir in the '$TEMPMOUNTDIR' and start
					# a shell (bash) to be able to modify sth.
					( cd "${TEMPMOUNTDIR}/tmp/${ISOFILENAME}"; bash -i; )
				else
					echo "Mounting into a loopback-device failed." 1>&2
					echo "(perhaps you have to be root, but caution:" 1>&2
					echo " that could be a security risk!)" 1>&2
					rm -rf "${TEMPMOUNTDIR}"
					sleep 3s
					exit 1
				fi  	
			;;
			$[$a+1]) # if you choose 'apply':
				if [ -e "${TEMPMOUNTDIR}/tmp/${ISOFILENAME}" ]; then
					echo "1. clear the old ISO-file in ${BURNDIR}."
					# remove the old ISO-file
					rm -f "${ISOFILE}" 
					echo "2. create new iso-file (${ISOFILE})."
					# create a new one:
					eval "mkisofs -copyright \"$COPYRIGHT\" -A \"$DESCRIPTION\" \
				  	     -p \"$AUTHOR\" -P \"$PUBLISHER\" -volset \"$NAMEOFPACKAGE\" \
					     -volset-size \"$NUMBEROFCDS\" -volset-seqno \"$CURRENTNUMBER\" \
					     -V \"$LABEL\" -o ${BURNDIR}/BashBurn.iso -r -T -f -J -hide-joliet-trans-tbl \
					     "${TEMPMOUNTDIR}/tmp/${ISOFILENAME}"" 					
					echo "3. unmount loopback-device."
					# umount loopback-device (actually that had to be unmounted already)
					umount "${TEMPMOUNTDIR}/${i}" 2> /dev/null
					# erase all temporary files
					
					rm -rf "${TEMPMOUNTDIR}"
					
					echo "Now ready to burn!"
					sleep 3s
					break 2	# back to the menu of BashBurn.sh
				else
					echo "There is no directory (${TEMPMOUNTDIR}/tmp/${ISOFILENAME})" \
					     "that should be a copy of the mounted loopback-device." 1>&2	
					echo "You might view the content of an iso-file first.." 1>&2
					sleep 3s	
					exit 1
				fi
			;;
  			0) # if you choose 'back':
				# if the loopback-device is mounted, umount it
				if mount | grep -qie "${TEMPMOUNTDIR}/${ISOFILENAME}";  then
					umount "${TEMPMOUNTDIR}/${ISOFILENAME}"
				fi	
				
				# if TEMPMOUNTDIR exists, delete it
				if [ -e "${TEMPMOUNTDIR}" ]; then
					rm -rf "${TEMPMOUNTDIR}"
				fi
				break 2 # back to the main menu of BashBurn.sh
  			;;
  			*)
  				continue
			;;
		esac
	done
done
